Subject: Re: [PATCH v13 3/4] gpio: rpmsg: add generic rpmsg GPIO driver

From: Beleswar Prasad Padhi <[email-masked]>
Date: Thu, 30 Apr 2026 18:26:13 +0530

Hello Arnaud,

On 30/04/26 13:05, Arnaud POULIQUEN wrote:
> Hello,
>
> On 4/29/26 21:20, Mathieu Poirier wrote:
>> On Wed, 29 Apr 2026 at 12:07, Padhi, Beleswar <[email-masked]> wrote:
>>>
>>> Hi Mathieu,
>>>
>>> On 4/29/2026 11:03 PM, Mathieu Poirier wrote:
>>>> On Wed, 29 Apr 2026 at 10:53, Shenwei Wang <[email-masked]> wrote:
>>>>>
>>>>>
>>>>>> -----Original Message-----
>>>>>> From: Mathieu Poirier <[email-masked]>
>>>>>> Sent: Wednesday, April 29, 2026 10:42 AM
>>>>>> To: Shenwei Wang <[email-masked]>
>>>>>> Cc: Andrew Lunn <[email-masked]>; Padhi, Beleswar <[email-masked]>; Linus
>>>>>> Walleij <[email-masked]>; Bartosz Golaszewski <[email-masked]>; Jonathan
>>>>>> Corbet <[email-masked]>; Rob Herring <[email-masked]>; Krzysztof Kozlowski
>>>>>> <[email-masked]>; Conor Dooley <[email-masked]>; Bjorn Andersson
>>>>>> <[email-masked]>; Frank Li <[email-masked]>; Sascha Hauer
>>>>>> <[email-masked]>; Shuah Khan <[email-masked]>; linux-
>>>>>> [email-masked]; [email-masked]; [email-masked];
>>>>>> Pengutronix Kernel Team <[email-masked]>; Fabio Estevam
>>>>>> <[email-masked]>; Peng Fan <[email-masked]>;
>>>>>> [email-masked]; [email-masked];
>>>>>> [email-masked]; [email-masked]; dl-linux-imx <linux-
>>>>>> [email-masked]>; Bartosz Golaszewski <[email-masked]>
>>>>>> Subject: [EXT] Re: [PATCH v13 3/4] gpio: rpmsg: add generic rpmsg GPIO driver
>>>>>> On Tue, Apr 28, 2026 at 03:24:59PM +0000, Shenwei Wang wrote:
>>>>>>>
>>>>>>>> -----Original Message-----
>>>>>>>> From: Andrew Lunn <[email-masked]>
>>>>>>>> Sent: Monday, April 27, 2026 3:49 PM
>>>>>>>> To: Shenwei Wang <[email-masked]>
>>>>>>>> Cc: Padhi, Beleswar <[email-masked]>; Linus Walleij
>>>>>>>> <[email-masked]>; Bartosz Golaszewski <[email-masked]>; Jonathan
>>>>>>>> Corbet <[email-masked]>; Rob Herring <[email-masked]>; Krzysztof
>>>>>>>> Kozlowski <[email-masked]>; Conor Dooley <[email-masked]>;
>>>>>>>> Bjorn Andersson <[email-masked]>; Mathieu Poirier
>>>>>>>> <[email-masked]>; Frank Li <[email-masked]>; Sascha
>>>>>>>> Hauer <[email-masked]>; Shuah Khan
>>>>>>>> <[email-masked]>; [email-masked]; linux-
>>>>>>>> [email-masked]; [email-masked]; Pengutronix
>>>>>>>> Kernel Team <[email-masked]>; Fabio Estevam
>>>>>>>> <[email-masked]>; Peng Fan <[email-masked]>;
>>>>>>>> [email-masked]; linux- [email-masked];
>>>>>>>> [email-masked]; linux-arm- [email-masked];
>>>>>>>> dl-linux-imx <[email-masked]>; Bartosz Golaszewski
>>>>>>>> <[email-masked]>
>>>>>>>> Subject: [EXT] Re: [PATCH v13 3/4] gpio: rpmsg: add generic rpmsg
>>>>>>>> GPIO driver
>>>>>>>>>> struct virtio_gpio_response {
>>>>>>>>>>           __u8 status;
>>>>>>>>>>           __u8 value;
>>>>>>>>>> };
>>>>>>>>> It is the same message format. Please see the message definition
>>>>>>>> (GET_DIRECTION) below:
>>>>>>>>
>>>>>>>>> +   +-----+-----+-----+-----+-----+----+
>>>>>>>>> +   |0x00 |0x01 |0x02 |0x03 |0x04 |0x05|
>>>>>>>>> +   | 1   | 2   |port |line | err | dir|
>>>>>>>>> +   +-----+-----+-----+-----+-----+----+
>>>>>>>> Sorry, but i don't see how two u8 vs six u8 are the same message format.
>>>>>>>>
>>>>>>> Some changes to the message format are necessary.
>>>>>>>
>>>>>>> Virtio uses two communication channels (virtqueues): one for requests and
>>>>>> replies, and a second one for events.
>>>>>>> In contrast, rpmsg provides only a single communication channel, so a
>>>>>>> type field is required to distinguish between different kinds of messages.
>>>>>>>
>>>>>>> Since rpmsg replies and events share the same message format, an additional
>>>>>> line is introduced to handle both cases.
>>>>>>> Finally, rpmsg supports multiple GPIO controllers, so a port field is added to
>>>>>> uniquely identify the target controller.
>>>>>>
>>>>>> I have commented on this before - RPMSG is already providing multiplexing
>>>>>> capability by way of endpoints.  There is no need for a port field.  One endpoint,
>>>>>> one GPIO controller.
>>>>>>
>>>>> You still need a way to let the remote side know which port the endpoint maps to, either
>>>>> by embedding the port information in the message (the current way), or by sending it
>>>>> separately.
>>>>>
>>>> An endpoint is created with every namespace request.  There should be
>>>> one namespace request for every GPIO controller, which yields a unique
>>>> endpoint for each controller and eliminates the need for an extra
>>>> field to identify them.
>>>
>>>
>>> Right, but this can still be done by just having one namespace request.
>>> We can create new endpoints bound to an existing namespace/channel by
>>> invoking rpmsg_create_ept(). This is what I suggested here too:
>>> https://lore.kernel.org/all/[email-masked]/
>>>
>>
>> I will look at your suggestion (i.e link above) later this week or next week.
>>
>>> My mental model looks like this for the complete picture:
>>>
>>> 1. namespace/channel#1 = rpmsg-io
>>>      a. ept1 -> gpio-controller@1
>>>      b. ept2 -> gpio-controller@2
>>>
>>
>> I've asked for one endpoint per GPIO controller since the very
>> beginning.  I don't yet have a strong opinion on whether to use one
>> namespace request per GPIO controller or a single request that spins
>> off multiple endpoints.  I'll have to look at your link and reflect on
>> that.  Regardless of how we proceed on that front, multiplexing needs
>> to happen at the endpoint level rather than the packet level.  This is
>> the only way this work can move forward.
>>
>
> I would be more in favor of Mathieu’s proposal: “An endpoint is created with every namespace request.”
>
> If the endpoint is created only on the Linux side, how do we match the Linux endpoint address with the local port field on the remote side? 

Simply by sending a message to the remote containing the newly created
endpoint and the port idx. Note that is this done just one time, after this
Linux need not have the port field in the message everytime its sending
a message.

>
> With a multi-namespace approach, the namespace could be rpmsg-io-[addr], where [addr] corresponds to the GPIO controller address in the DT. This would: 

You will face the same problem in this case also that you asked above:
"how do we match the Linux endpoint address with the local port field
on the remote side?"

Because the endpoint that is created on a namespace request is also
dynamic in nature. How will the remote know which endpoint addr
Linux allocated for a namespace that it announced?

As an example/PoC, I created a firmware example which announces
2 name services to Linux, one is the standard "rpmsg_chrdev" and
the other is a TI specific name service "ti.ipc4.ping-pong". You can
see it created 2 different addresses (0x400 and 0x401) for each of
the name service request from the same firmware:

root@j784s4-evm:~# dmesg | grep virtio0 | grep -i channel                                                                                                                                                   
[    9.290275] virtio_rpmsg_bus virtio0: creating channel ti.ipc4.ping-pong addr 0xd
[    9.311230] virtio_rpmsg_bus virtio0: creating channel rpmsg_chrdev addr 0xe
[    9.496645] rpmsg_chrdev virtio0.rpmsg_chrdev.-1.14: DEBUG: Channel formed from src = 0x400 to dst = 0xe
[    9.707255] rpmsg_client_sample virtio0.ti.ipc4.ping-pong.-1.13: new channel: 0x401 -> 0xd!

So in this case, rpmsg-io-1 can have different ept addr than rpmsg-io-2
Back to same problem. Simple solution is to reply to remote with the
created ept addr and the index.

>
> - match the RPMsg probe with the DT, 

We can probe from all controllers with a single name service
announcement too.

> - provide a simple mapping between the port and the endpoint on both sides, 

We are trying to get rid of this mapping from Linux side to adapt
the gpio-virtio design.

> - allow multiple endpoints on the remote side, 

We can support this as well with single nameservice model.
There is no limitation. Remote has to send a message with
its newly created ept that's all.

> - provide a simple discovery mechanism for remote capabilities. 

A single announcement: "rpmsg-io" is also discovery mechanism.

Feel free to let me know if you have concerns with any of the
suggestions!

Thanks,
Beleswar

>
> Regards,
> Arnaud
>
>>> 2. namespace/channel#2 = rpmsg-i2c
>>>      a. ept1 -> i2c@1
>>>      b. ept2 -> i2c@2
>>>      c. ept3 -> i2c@3
>>>
>>> etc...
>>>
>>> This way device groups are isolated with each channel/namespace, and
>>> instances within each device groups are also respected with specific
>>> endpoints.
>>>
>>> Thanks,
>>> Beleswar
>>>
>>
>